
import { _decorator, Component, Node, SpriteFrame, Sprite, Animation, AnimationClip, CCInteger } from 'cc';
const { ccclass, property } = _decorator;
 
@ccclass('AnimationTest')
export class AnimationTest extends Component {
 
    @property(Node)
    public target: Node;

    @property([SpriteFrame])
    public frames: [SpriteFrame];

    @property(CCInteger)
    public animSpeed: number;

    onLoad(){
        this.createAnimation();
    }

    createAnimation(){
        let item = this.target;
        let animation = item.addComponent(Animation);

        let clip = AnimationClip.createWithSpriteFrames(this.frames, this.animSpeed);
        clip.name = 'item';
        
        //animation.clips.push(clip);
        //animation.defaultClip = clip;
        //animation.playOnLoad = true;

        animation.on(Animation.EventType.FINISHED, () => {
            console.log("Animation Finished");
            //item.destroy();
        });

        // animation.play();
        let state = animation.createState(clip, 'item')!;
        state.play();

        console.log(item);
        console.log(animation);
        console.log(clip);
        console.log(state);
        //animation.play('item');
    }

}

